Merge pull request #23220 from BruceForstall/FixArm64HfaJmpCallNyi
[platform/upstream/coreclr.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Work around Jenkins CI + msbuild problem: Jenkins sometimes creates very large environment
4 # variables, and msbuild can't handle environment blocks with such large variables. So clear
5 # out the variables that might be too large.
6 export ghprbCommentBody=
7
8 # resolve python-version to use
9 if [ "$PYTHON" == "" ] ; then
10     if ! PYTHON=$(command -v python3 || command -v python2 || command -v python || command -v py)
11     then
12        echo "Unable to locate build-dependency python!" 1>&2
13        exit 1
14     fi
15 fi
16 # validate python-dependency
17 # useful in case of explicitly set option.
18 if ! command -v $PYTHON > /dev/null
19 then
20    echo "Unable to locate build-dependency python ($PYTHON)!" 1>&2
21    exit 1
22 fi
23
24 export PYTHON
25
26 usage()
27 {
28     echo "Usage: $0 [BuildArch] [BuildType] [-verbose] [-coverage] [-cross] [-gccx.y] [-clangx.y] [-ninja] [-configureonly] [-skipconfigure] [-skipnative] [-skipcrossarchnative] [-skipmanaged] [-skipmscorlib] [-skiptests] [-stripsymbols] [-ignorewarnings] [-cmakeargs] [-bindir]"
29     echo "BuildArch can be: -x64, -x86, -arm, -armel, -arm64"
30     echo "BuildType can be: -debug, -checked, -release"
31     echo "-coverage - optional argument to enable code coverage build (currently supported only for Linux and OSX)."
32     echo "-ninja - target ninja instead of GNU make"
33     echo "-gccx.y - optional argument to build using gcc version x.y."
34     echo "-clangx.y - optional argument to build using clang version x.y."
35     echo "-cross - optional argument to signify cross compilation,"
36     echo "       - will use ROOTFS_DIR environment variable if set."
37     echo "-nopgooptimize - do not use profile guided optimizations."
38     echo "-pgoinstrument - generate instrumented code for profile guided optimization enabled binaries."
39     echo "-ibcinstrument - generate IBC-tuning-enabled native images when invoking crossgen."
40     echo "-configureonly - do not perform any builds; just configure the build."
41     echo "-skipconfigure - skip build configuration."
42     echo "-skipnative - do not build native components."
43     echo "-skipcrossarchnative - do not build cross-architecture native components."
44     echo "-skipmanaged - do not build managed components."
45     echo "-skipmscorlib - do not build mscorlib.dll."
46     echo "-skiptests - skip the tests in the 'tests' subdirectory."
47     echo "-skipnuget - skip building nuget packages."
48     echo "-skiprestoreoptdata - skip restoring optimization data used by profile-based optimizations."
49     echo "-skipcrossgen - skip native image generation"
50     echo "-crossgenonly - only run native image generation"
51     echo "-partialngen - build CoreLib as PartialNGen"
52     echo "-verbose - optional argument to enable verbose build output."
53     echo "-skiprestore: skip restoring packages ^(default: packages are restored during build^)."
54     echo "-disableoss: Disable Open Source Signing for System.Private.CoreLib."
55     echo "-officialbuildid=^<ID^>: specify the official build ID to be used by this build."
56     echo "-stripSymbols - Optional argument to strip native symbols during the build."
57     echo "-skipgenerateversion - disable version generation even if MSBuild is supported."
58     echo "-ignorewarnings - do not treat warnings as errors"
59     echo "-cmakeargs - user-settable additional arguments passed to CMake."
60     echo "-bindir - output directory (defaults to $__ProjectRoot/bin)"
61     echo "-msbuildonunsupportedplatform - build managed binaries even if distro is not officially supported."
62     echo "-numproc - set the number of build processes."
63     echo "-portablebuild - pass -portablebuild=false to force a non-portable build."
64     echo "-staticanalyzer - build with clang static analyzer enabled."
65     exit 1
66 }
67
68 initTargetDistroRid()
69 {
70     source init-distro-rid.sh
71
72     local passedRootfsDir=""
73
74     # Only pass ROOTFS_DIR if cross is specified.
75     if (( ${__CrossBuild} == 1 )); then
76         passedRootfsDir=${ROOTFS_DIR}
77     elif [ "${__BuildArch}" != "${__HostArch}" ]; then
78         echo "Error, you are building a cross scenario without passing -cross."
79         exit 1
80     fi
81
82     initDistroRidGlobal ${__BuildOS} ${__BuildArch} ${__PortableBuild} ${passedRootfsDir}
83 }
84
85 setup_dirs()
86 {
87     echo Setting up directories for build
88
89     mkdir -p "$__RootBinDir"
90     mkdir -p "$__BinDir"
91     mkdir -p "$__LogsDir"
92     mkdir -p "$__MsbuildDebugLogsDir"
93     mkdir -p "$__IntermediatesDir"
94
95     if [ $__CrossBuild == 1 ]; then
96         mkdir -p "$__CrossComponentBinDir"
97     fi
98 }
99
100 # Check the system to ensure the right prereqs are in place
101
102 check_prereqs()
103 {
104     echo "Checking prerequisites..."
105
106     # Check presence of CMake on the path
107     hash cmake 2>/dev/null || { echo >&2 "Please install cmake before running this script"; exit 1; }
108
109
110     # Minimum required version of clang is version 4.0 for arm/armel cross build
111     if [[ $__CrossBuild == 1 && $__GccBuild == 0 &&  ("$__BuildArch" == "arm" || "$__BuildArch" == "armel") ]]; then
112         if ! [[ "$__ClangMajorVersion" -ge "4" ]]; then
113             echo "Please install clang4.0 or latest for arm/armel cross build"; exit 1;
114         fi
115     fi
116
117     # Check for clang
118     if [[ $__GccBuild == 0 ]]; then
119         __ClangCombinedDottedVersion=$__ClangMajorVersion;
120         if [[ "$__ClangMinorVersion" != "" ]]; then
121             __ClangCombinedDottedVersion=$__ClangCombinedDottedVersion.$__ClangMinorVersion
122         fi
123         hash clang-$__ClangCombinedDottedVersion 2>/dev/null ||  hash clang$__ClangMajorVersion$__ClangMinorVersion 2>/dev/null || hash clang 2>/dev/null || { echo >&2 "Please install clang-$__ClangMajorVersion.$__ClangMinorVersion before running this script"; exit 1; }
124     else
125         __GccCombinedDottedVersion=$__GccMajorVersion;
126         if [[ "$__GccMinorVersion" != "" ]]; then
127             __GccCombinedDottedVersion=$__GccCombinedDottedVersion.$__GccMinorVersion
128         fi
129         hash gcc-$__GccCombinedDottedVersion 2>/dev/null ||  hash gcc$__GccMajorVersion$__GccMinorVersion 2>/dev/null || hash gcc 2>/dev/null || { echo >&2 "Please install gcc-$__GccMajorVersion.$__GccMinorVersion before running this script"; exit 1; }
130     fi
131
132 }
133
134 restore_optdata()
135 {
136     # we only need optdata on a Release build
137     if [[ "$__BuildType" != "Release" ]]; then __SkipRestoreOptData=1; fi
138
139     if [[ ( $__SkipRestoreOptData == 0 ) && ( $__isMSBuildOnNETCoreSupported == 1 ) ]]; then
140         echo "Restoring the OptimizationData package"
141         "$__ProjectRoot/dotnet.sh" msbuild /nologo /verbosity:minimal /clp:Summary \
142                                    /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
143                                    /p:UsePartialNGENOptimization=false /maxcpucount \
144                                    /t:RestoreOptData ./build.proj \
145                                    $__CommonMSBuildArgs $__UnprocessedBuildArgs
146         if [ $? != 0 ]; then
147             echo "Failed to restore the optimization data package."
148             exit 1
149         fi
150     fi
151
152     if [ $__isMSBuildOnNETCoreSupported == 1 ]; then
153         # Parse the optdata package versions out of msbuild so that we can pass them on to CMake
154         local DotNetCli="$__ProjectRoot/.dotnet/dotnet"
155         if [ ! -f $DotNetCli ]; then
156             source "$__ProjectRoot/init-tools.sh"
157             if [ $? != 0 ]; then
158                 echo "Failed to restore buildtools."
159                 exit 1
160             fi
161         fi
162         local OptDataProjectFilePath="$__ProjectRoot/src/.nuget/optdata/optdata.csproj"
163         __PgoOptDataVersion=$(DOTNET_SKIP_FIRST_TIME_EXPERIENCE=1 $DotNetCli msbuild $OptDataProjectFilePath /t:DumpPgoDataPackageVersion /nologo | sed 's/^\s*//')
164         __IbcOptDataVersion=$(DOTNET_SKIP_FIRST_TIME_EXPERIENCE=1 $DotNetCli msbuild $OptDataProjectFilePath /t:DumpIbcDataPackageVersion /nologo | sed 's/^[[:blank:]]*//')
165     fi
166 }
167
168 generate_event_logging_sources()
169 {
170     __OutputDir=$1
171     __ConsumingBuildSystem=$2
172
173     __OutputIncDir="$__OutputDir/src/inc"
174     __OutputEventingDir="$__OutputDir/Eventing"
175     __OutputEventProviderDir="$__OutputEventingDir/eventprovider"
176
177     echo "Laying out dynamically generated files consumed by $__ConsumingBuildSystem"
178     echo "Laying out dynamically generated Event test files, etmdummy stub functions, and external linkages"
179
180     __PythonWarningFlags="-Wall"
181     if [[ $__IgnoreWarnings == 0 ]]; then
182         __PythonWarningFlags="$__PythonWarningFlags -Werror"
183     fi
184
185     $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genEventing.py" --inc $__OutputIncDir --dummy $__OutputIncDir/etmdummy.h --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --testdir "$__OutputEventProviderDir/tests"
186     if [[ $? != 0 ]]; then
187         exit 1
188     fi
189
190     echo "Laying out dynamically generated EventPipe Implementation"
191     $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genEventPipe.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__OutputEventingDir/eventpipe"
192
193     echo "Laying out dynamically generated EventSource classes"
194     $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genRuntimeEventSources.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__OutputEventingDir"
195
196     # determine the logging system
197     case $__BuildOS in
198         Linux|FreeBSD)
199             echo "Laying out dynamically generated Event Logging Implementation of Lttng"
200             $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genLttngProvider.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__OutputEventProviderDir"
201             if [[ $? != 0 ]]; then
202                 exit 1
203             fi
204             ;;
205         *)
206             echo "Laying out dummy event logging provider"
207             $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genDummyProvider.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__OutputEventProviderDir"
208             if [[ $? != 0 ]]; then
209                 exit 1
210             fi
211             ;;
212     esac
213 }
214
215 generate_event_logging()
216 {
217     # Event Logging Infrastructure
218     if [[ $__SkipCoreCLR == 0 || $__SkipMSCorLib == 0 || $__ConfigureOnly == 1 ]]; then
219         generate_event_logging_sources "$__IntermediatesDir" "the native build system"
220     fi
221 }
222
223 build_native()
224 {
225     skipCondition=$1
226     platformArch="$2"
227     intermediatesForBuild="$3"
228     extraCmakeArguments="$4"
229     message="$5"
230
231     if [ $skipCondition == 1 ]; then
232         echo "Skipping $message build."
233         return
234     fi
235
236     # All set to commence the build
237     echo "Commencing build of $message for $__BuildOS.$__BuildArch.$__BuildType in $intermediatesForBuild"
238
239     generator=""
240     buildFile="Makefile"
241     buildTool="make"
242     if [ $__UseNinja == 1 ]; then
243         generator="ninja"
244         buildFile="build.ninja"
245         if ! buildTool=$(command -v ninja || command -v ninja-build); then
246            echo "Unable to locate ninja!" 1>&2
247            exit 1
248         fi
249     fi
250
251     if [ $__SkipConfigure == 0 ]; then
252         # if msbuild is not supported, then set __SkipGenerateVersion to 1
253         if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipGenerateVersion=1; fi
254         # Drop version.c file
255         __versionSourceFile="$intermediatesForBuild/version.c"
256         if [ $__SkipGenerateVersion == 0 ]; then
257             pwd
258             "$__ProjectRoot/dotnet.sh" msbuild /nologo /verbosity:minimal /clp:Summary \
259                                        /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
260                                        /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
261                                        /p:UsePartialNGENOptimization=false /maxcpucount \
262                                        "$__ProjectDir/build.proj" /p:GenerateVersionSourceFile=true /t:GenerateVersionSourceFile /p:NativeVersionSourceFile=$__versionSourceFile \
263                                        $__CommonMSBuildArgs $__UnprocessedBuildArgs
264         else
265             # Generate the dummy version.c, but only if it didn't exist to make sure we don't trigger unnecessary rebuild
266             __versionSourceLine="static char sccsid[] __attribute__((used)) = \"@(#)No version information produced\";"
267             if [ -e $__versionSourceFile ]; then
268                 read existingVersionSourceLine < $__versionSourceFile
269             fi
270             if [ "$__versionSourceLine" != "$existingVersionSourceLine" ]; then
271                 echo $__versionSourceLine > $__versionSourceFile
272             fi
273         fi
274
275
276         pushd "$intermediatesForBuild"
277         # Regenerate the CMake solution
278
279         if [[ $__GccBuild == 0 ]]; then
280             scan_build=
281             if [[ $__StaticAnalyzer == 1 ]]; then
282                 scan_build=scan-build
283             fi
284             echo "Invoking \"$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh\" \"$__ProjectRoot\" $__ClangMajorVersion \"$__ClangMinorVersion\" $platformArch $__BuildType $__CodeCoverage $scan_build $generator $extraCmakeArguments $__cmakeargs"
285             source "$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh" "$__ProjectRoot" $__ClangMajorVersion "$__ClangMinorVersion" $platformArch $__BuildType $__CodeCoverage $scan_build $generator "$extraCmakeArguments" "$__cmakeargs"
286         else
287             echo "Invoking \"$__ProjectRoot/src/pal/tools/gen-buildsys-gcc.sh\" \"$__ProjectRoot\" $__GccMajorVersion \"$__GccMinorVersion\" $platformArch $__BuildType $__CodeCoverage $generator $extraCmakeArguments $__cmakeargs"
288             source "$__ProjectRoot/src/pal/tools/gen-buildsys-gcc.sh" "$__ProjectRoot" "$__GccMajorVersion" "$__CGccMinorVersion" $platformArch $__BuildType $__CodeCoverage $generator "$extraCmakeArguments" "$__cmakeargs"
289         fi
290         popd
291     fi
292
293     if [ ! -f "$intermediatesForBuild/$buildFile" ]; then
294         echo "Failed to generate $message build project!"
295         exit 1
296     fi
297
298     # Build
299     if [ $__ConfigureOnly == 1 ]; then
300         echo "Finish configuration & skipping $message build."
301         return
302     fi
303
304     # Check that the makefiles were created.
305     pushd "$intermediatesForBuild"
306
307     if [ $__StaticAnalyzer == 1 ]; then
308         buildTool="$SCAN_BUILD_COMMAND $buildTool"
309     fi
310
311     echo "Executing $buildTool install -j $__NumProc"
312
313     $buildTool install -j $__NumProc
314     if [ $? != 0 ]; then
315         echo "Failed to build $message."
316         exit 1
317     fi
318
319     popd
320 }
321
322 build_cross_architecture_components()
323 {
324     local intermediatesForBuild="$__IntermediatesDir/Host$__CrossArch/crossgen"
325     local crossArchBinDir="$__BinDir/$__CrossArch"
326
327     mkdir -p "$intermediatesForBuild"
328     mkdir -p "$crossArchBinDir"
329
330     generate_event_logging_sources "$intermediatesForBuild" "the crossarch build system"
331
332     __SkipCrossArchBuild=1
333     # check supported cross-architecture components host(__HostArch)/target(__BuildArch) pair
334     if [[ ("$__BuildArch" == "arm" || "$__BuildArch" == "armel") && ("$__CrossArch" == "x86" || "$__CrossArch" == "x64") ]]; then
335         __SkipCrossArchBuild=0
336     elif [[ "$__BuildArch" == "arm64" && "$__CrossArch" == "x64" ]]; then
337         __SkipCrossArchBuild=0
338     else
339         # not supported
340         return
341     fi
342
343     export __CMakeBinDir="$crossArchBinDir"
344     export CROSSCOMPILE=0
345
346     __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_ARCH=$__BuildArch -DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion -DCLR_CMAKE_PGO_OPTIMIZE=$__PgoOptimize -DCLR_CROSS_COMPONENTS_BUILD=1"
347     build_native $__SkipCrossArchBuild "$__CrossArch" "$intermediatesForBuild" "$__ExtraCmakeArgs" "cross-architecture components"
348
349     export CROSSCOMPILE=1
350 }
351
352 isMSBuildOnNETCoreSupported()
353 {
354     __isMSBuildOnNETCoreSupported=$__msbuildonunsupportedplatform
355
356     if [ $__isMSBuildOnNETCoreSupported == 1 ]; then
357         return
358     fi
359
360     if [ $__SkipManaged == 1 ]; then
361         __isMSBuildOnNETCoreSupported=0
362         return
363     fi
364
365     if [ "$__HostArch" == "x64" ]; then
366         if [ "$__HostOS" == "Linux" ]; then
367             __isMSBuildOnNETCoreSupported=1
368             # note: the RIDs below can use globbing patterns
369             UNSUPPORTED_RIDS=("ubuntu.17.04-x64")
370             for UNSUPPORTED_RID in "${UNSUPPORTED_RIDS[@]}"
371             do
372                 if [[ ${__DistroRid} == $UNSUPPORTED_RID ]]; then
373                     __isMSBuildOnNETCoreSupported=0
374                     break
375                 fi
376             done
377         elif [ "$__HostOS" == "OSX" ]; then
378             __isMSBuildOnNETCoreSupported=1
379         elif [ "$__HostOS" == "FreeBSD" ]; then
380             __isMSBuildOnNETCoreSupported=1
381         fi
382     fi
383 }
384
385
386 build_CoreLib_ni()
387 {
388     local __CrossGenExec=$1
389
390     if [ $__PartialNgen == 1 ]; then
391         export COMPlus_PartialNGen=1
392     fi
393
394     if [ -e $__CrossGenCoreLibLog ]; then
395         rm $__CrossGenCoreLibLog
396     fi
397     echo "Generating native image of System.Private.CoreLib.dll for $__BuildOS.$__BuildArch.$__BuildType. Logging to \"$__CrossGenCoreLibLog\"."
398     echo "$__CrossGenExec /Platform_Assemblies_Paths $__BinDir/IL $__IbcTuning /out $__BinDir/System.Private.CoreLib.dll $__BinDir/IL/System.Private.CoreLib.dll"
399     $__CrossGenExec /Platform_Assemblies_Paths $__BinDir/IL $__IbcTuning /out $__BinDir/System.Private.CoreLib.dll $__BinDir/IL/System.Private.CoreLib.dll >> $__CrossGenCoreLibLog 2>&1
400     if [ $? -ne 0 ]; then
401         echo "Failed to generate native image for System.Private.CoreLib. Refer to $__CrossGenCoreLibLog"
402         exit 1
403     fi
404
405     if [ "$__BuildOS" == "Linux" ]; then
406         echo "Generating symbol file for System.Private.CoreLib.dll"
407         echo "$__CrossGenExec /Platform_Assemblies_Paths $__BinDir /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.dll"
408         $__CrossGenExec /Platform_Assemblies_Paths $__BinDir /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.dll >> $__CrossGenCoreLibLog 2>&1
409         if [ $? -ne 0 ]; then
410             echo "Failed to generate symbol file for System.Private.CoreLib. Refer to $__CrossGenCoreLibLog"
411             exit 1
412         fi
413     fi
414 }
415
416 build_CoreLib()
417 {
418     if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
419         echo "System.Private.CoreLib.dll build unsupported."
420         return
421     fi
422
423     if [ $__SkipMSCorLib == 1 ]; then
424        echo "Skipping building System.Private.CoreLib."
425        return
426     fi
427
428     echo "Commencing build of managed components for $__BuildOS.$__BuildArch.$__BuildType"
429
430     # Invoke MSBuild
431     __ExtraBuildArgs=""
432     if [[ "$__IbcTuning" == "" ]]; then
433         __ExtraBuildArgs="$__ExtraBuildArgs /p:OptimizationDataDir=\"$__PackagesDir/optimization.$__BuildOS-$__BuildArch.IBC.CoreCLR/$__IbcOptDataVersion/data\""
434         __ExtraBuildArgs="$__ExtraBuildArgs /p:EnableProfileGuidedOptimization=true"
435     fi
436
437     if [[ "$__BuildManagedTools" -eq "1" ]]; then
438         __ExtraBuildArgs="$__ExtraBuildArgs /p:BuildManagedTools=true"
439     fi
440
441     $__ProjectRoot/dotnet.sh msbuild /nologo /verbosity:minimal /clp:Summary \
442                              /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
443                              /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
444                              /p:UsePartialNGENOptimization=false /maxcpucount \
445                              $__ProjectDir/build.proj \
446                              /flp:Verbosity=normal\;LogFile=$__LogsDir/System.Private.CoreLib_$__BuildOS__$__BuildArch__$__BuildType.log \
447                              /p:__IntermediatesDir=$__IntermediatesDir /p:__RootBinDir=$__RootBinDir /p:BuildNugetPackage=false \
448                              $__CommonMSBuildArgs $__ExtraBuildArgs $__UnprocessedBuildArgs
449
450     if [ $? -ne 0 ]; then
451         echo "Failed to build managed components."
452         exit 1
453     fi
454
455     if [ $__SkipCrossgen == 1 ]; then
456         echo "Skipping generating native image"
457         return
458     fi
459
460     # The cross build generates a crossgen with the target architecture.
461     if [ $__CrossBuild == 0 ]; then
462        if [ $__SkipCoreCLR == 1 ]; then
463            return
464        fi
465
466        # The architecture of host pc must be same architecture with target.
467        if [[ ( "$__HostArch" == "$__BuildArch" ) ]]; then
468            build_CoreLib_ni "$__BinDir/crossgen"
469        elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "x86" ) ]]; then
470            build_CoreLib_ni "$__BinDir/crossgen"
471        elif [[ ( "$__HostArch" == "arm64" ) && ( "$__BuildArch" == "arm" ) ]]; then
472            build_CoreLib_ni "$__BinDir/crossgen"
473        else
474            exit 1
475        fi
476     else
477        if [[ ( "$__CrossArch" == "x86" ) && ( "$__BuildArch" == "arm" ) ]]; then
478            build_CoreLib_ni "$__CrossComponentBinDir/crossgen"
479        elif [[ ( "$__CrossArch" == "x64" ) && ( "$__BuildArch" == "arm" ) ]]; then
480            build_CoreLib_ni "$__CrossComponentBinDir/crossgen"
481        elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "arm64" ) ]]; then
482            build_CoreLib_ni "$__CrossComponentBinDir/crossgen"
483        fi
484     fi
485 }
486
487 generate_NugetPackages()
488 {
489     # We can only generate nuget package if we also support building mscorlib as part of this build.
490     if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
491         echo "Nuget package generation unsupported."
492         return
493     fi
494
495     # Since we can build mscorlib for this OS, did we build the native components as well?
496     if [[ $__SkipCoreCLR == 1 && $__CrossgenOnly == 0 ]]; then
497         echo "Unable to generate nuget packages since native components were not built."
498         return
499     fi
500
501     echo "Generating nuget packages for "$__BuildOS
502     echo "DistroRid is "$__DistroRid
503     echo "ROOTFS_DIR is "$ROOTFS_DIR
504     # Build the packages
505     $__ProjectRoot/dotnet.sh msbuild /nologo /verbosity:minimal /clp:Summary \
506                              /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
507                              /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
508                              /p:UsePartialNGENOptimization=false /maxcpucount \
509                              $__SourceDir/.nuget/packages.builds \
510                              /flp:Verbosity=normal\;LogFile=$__LogsDir/Nuget_$__BuildOS__$__BuildArch__$__BuildType.log \
511                              /p:__IntermediatesDir=$__IntermediatesDir /p:__RootBinDir=$__RootBinDir /p:BuildNugetPackages=false /p:__DoCrossArchBuild=$__CrossBuild \
512                              $__CommonMSBuildArgs $__UnprocessedBuildArgs
513
514     if [ $? -ne 0 ]; then
515         echo "Failed to generate Nuget packages."
516         exit 1
517     fi
518 }
519
520 echo "Commencing CoreCLR Repo build"
521
522 # Argument types supported by this script:
523 #
524 # Build architecture - valid values are: x64, ARM.
525 # Build Type         - valid values are: Debug, Checked, Release
526 #
527 # Set the default arguments for build
528
529 # Obtain the location of the bash script to figure out where the root of the repo is.
530 __ProjectRoot="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
531
532 # Use uname to determine what the CPU is.
533 CPUName=$(uname -p)
534 # Some Linux platforms report unknown for platform, but the arch for machine.
535 if [ "$CPUName" == "unknown" ]; then
536     CPUName=$(uname -m)
537 fi
538
539 case $CPUName in
540     i686)
541         echo "Unsupported CPU $CPUName detected, build might not succeed!"
542         __BuildArch=x86
543         __HostArch=x86
544         ;;
545
546     x86_64)
547         __BuildArch=x64
548         __HostArch=x64
549         ;;
550
551     armv7l)
552         echo "Unsupported CPU $CPUName detected, build might not succeed!"
553         __BuildArch=arm
554         __HostArch=arm
555         ;;
556
557     aarch64)
558         __BuildArch=arm64
559         __HostArch=arm64
560         ;;
561
562     amd64)
563         __BuildArch=x64
564         __HostArch=x64
565         ;;
566     *)
567         echo "Unknown CPU $CPUName detected, configuring as if for x64"
568         __BuildArch=x64
569         __HostArch=x64
570         ;;
571 esac
572
573 # Use uname to determine what the OS is.
574 OSName=$(uname -s)
575 case $OSName in
576     Linux)
577         __BuildOS=Linux
578         __HostOS=Linux
579         ;;
580
581     Darwin)
582         __BuildOS=OSX
583         __HostOS=OSX
584         ;;
585
586     FreeBSD)
587         __BuildOS=FreeBSD
588         __HostOS=FreeBSD
589         ;;
590
591     OpenBSD)
592         __BuildOS=OpenBSD
593         __HostOS=OpenBSD
594         ;;
595
596     NetBSD)
597         __BuildOS=NetBSD
598         __HostOS=NetBSD
599         ;;
600
601     SunOS)
602         __BuildOS=SunOS
603         __HostOS=SunOS
604         ;;
605
606     *)
607         echo "Unsupported OS $OSName detected, configuring as if for Linux"
608         __BuildOS=Linux
609         __HostOS=Linux
610         ;;
611 esac
612
613 __BuildType=Debug
614 __CodeCoverage=
615 __IgnoreWarnings=0
616
617 # Set the various build properties here so that CMake and MSBuild can pick them up
618 __ProjectDir="$__ProjectRoot"
619 __SourceDir="$__ProjectDir/src"
620 __PackagesDir="${DotNetRestorePackagesPath:-${__ProjectDir}/packages}"
621 __RootBinDir="$__ProjectDir/bin"
622 __UnprocessedBuildArgs=
623 __CommonMSBuildArgs=
624 __MSBCleanBuildArgs=
625 __UseNinja=0
626 __VerboseBuild=0
627 __PgoInstrument=0
628 __PgoOptimize=1
629 __IbcTuning=""
630 __ConfigureOnly=0
631 __SkipConfigure=0
632 __SkipManaged=0
633 __SkipRestore=""
634 __SkipNuget=0
635 __SkipCoreCLR=0
636 __SkipCrossArchNative=0
637 __SkipMSCorLib=0
638 __SkipRestoreOptData=0
639 __SkipCrossgen=0
640 __CrossgenOnly=0
641 __PartialNgen=0
642 __SkipTests=0
643 __CrossBuild=0
644 __ClangMajorVersion=0
645 __ClangMinorVersion=0
646 __GccBuild=0
647 __GccMajorVersion=0
648 __GccMinorVersion=0
649 __NuGetPath="$__PackagesDir/NuGet.exe"
650 __DistroRid=""
651 __cmakeargs=""
652 __SkipGenerateVersion=0
653 __PortableBuild=1
654 __msbuildonunsupportedplatform=0
655 __PgoOptDataVersion=""
656 __IbcOptDataVersion=""
657 __BuildManagedTools=1
658 __SkipRestoreArg=""
659 __SignTypeArg=""
660 __OfficialBuildIdArg=""
661 __StaticAnalyzer=0
662
663 # Get the number of processors available to the scheduler
664 # Other techniques such as `nproc` only get the number of
665 # processors available to a single process.
666 if [ `uname` = "FreeBSD" ]; then
667   __NumProc=`sysctl hw.ncpu | awk '{ print $2+1 }'`
668 elif [ `uname` = "NetBSD" ]; then
669   __NumProc=$(($(getconf NPROCESSORS_ONLN)+1))
670 elif [ `uname` = "Darwin" ]; then
671   __NumProc=$(($(getconf _NPROCESSORS_ONLN)+1))
672 else
673   __NumProc=$(nproc --all)
674 fi
675
676 while :; do
677     if [ $# -le 0 ]; then
678         break
679     fi
680
681     lowerI="$(echo $1 | awk '{print tolower($0)}')"
682     case $lowerI in
683         -\?|-h|--help)
684             usage
685             exit 1
686             ;;
687
688         x86|-x86)
689             __BuildArch=x86
690             ;;
691
692         x64|-x64)
693             __BuildArch=x64
694             ;;
695
696         arm|-arm)
697             __BuildArch=arm
698             ;;
699
700         armel|-armel)
701             __BuildArch=armel
702             ;;
703
704         arm64|-arm64)
705             __BuildArch=arm64
706             ;;
707
708         debug|-debug)
709             __BuildType=Debug
710             ;;
711
712         checked|-checked)
713             __BuildType=Checked
714             ;;
715
716         release|-release)
717             __BuildType=Release
718             ;;
719
720         coverage|-coverage)
721             __CodeCoverage=Coverage
722             ;;
723
724         cross|-cross)
725             __CrossBuild=1
726             ;;
727
728         -portablebuild=false)
729             __PortableBuild=0
730             ;;
731
732         verbose|-verbose)
733             __VerboseBuild=1
734             ;;
735
736         stripsymbols|-stripsymbols)
737             __cmakeargs="$__cmakeargs -DSTRIP_SYMBOLS=true"
738             ;;
739
740         clang3.5|-clang3.5)
741             __ClangMajorVersion=3
742             __ClangMinorVersion=5
743             ;;
744
745         clang3.6|-clang3.6)
746             __ClangMajorVersion=3
747             __ClangMinorVersion=6
748             ;;
749
750         clang3.7|-clang3.7)
751             __ClangMajorVersion=3
752             __ClangMinorVersion=7
753             ;;
754
755         clang3.8|-clang3.8)
756             __ClangMajorVersion=3
757             __ClangMinorVersion=8
758             ;;
759
760         clang3.9|-clang3.9)
761             __ClangMajorVersion=3
762             __ClangMinorVersion=9
763             ;;
764
765         clang4.0|-clang4.0)
766             __ClangMajorVersion=4
767             __ClangMinorVersion=0
768             ;;
769
770         clang5.0|-clang5.0)
771             __ClangMajorVersion=5
772             __ClangMinorVersion=0
773             ;;
774
775         clang6.0|-clang6.0)
776             __ClangMajorVersion=6
777             __ClangMinorVersion=0
778             ;;
779
780         clang7|-clang7)
781             __ClangMajorVersion=7
782             __ClangMinorVersion=
783             ;;
784
785         gcc5|-gcc5)
786             __GccMajorVersion=5
787             __GccMinorVersion=
788             __GccBuild=1
789             ;;
790
791         gcc7|-gcc7)
792             __GccMajorVersion=7
793             __GccMinorVersion=
794             __GccBuild=1
795             ;;
796
797         gcc|-gcc)
798             __GccMajorVersion=
799             __GccMinorVersion=
800             __GccBuild=1
801             ;;
802
803         ninja|-ninja)
804             __UseNinja=1
805             ;;
806
807         pgoinstrument|-pgoinstrument)
808             __PgoInstrument=1
809             ;;
810
811         nopgooptimize|-nopgooptimize)
812             __PgoOptimize=0
813             __SkipRestoreOptData=1
814             ;;
815
816         ibcinstrument|-ibcinstrument)
817             __IbcTuning="/Tuning"
818             ;;
819
820         configureonly|-configureonly)
821             __ConfigureOnly=1
822             __SkipMSCorLib=1
823             __SkipNuget=1
824             ;;
825
826         skipconfigure|-skipconfigure)
827             __SkipConfigure=1
828             ;;
829
830         skipnative|-skipnative)
831             # Use "skipnative" to use the same option name as build.cmd.
832             __SkipCoreCLR=1
833             ;;
834
835         skipcoreclr|-skipcoreclr)
836             # Accept "skipcoreclr" for backwards-compatibility.
837             __SkipCoreCLR=1
838             ;;
839
840         skipcrossarchnative|-skipcrossarchnative)
841             __SkipCrossArchNative=1
842             ;;
843
844         skipmanaged|-skipmanaged)
845             __SkipManaged=1
846             ;;
847
848         skipmscorlib|-skipmscorlib)
849             __SkipMSCorLib=1
850             ;;
851
852         skipgenerateversion|-skipgenerateversion)
853             __SkipGenerateVersion=1
854             ;;
855
856         skiprestoreoptdata|-skiprestoreoptdata)
857             __SkipRestoreOptData=1
858             ;;
859
860         skipcrossgen|-skipcrossgen)
861             __SkipCrossgen=1
862             ;;
863
864         crossgenonly|-crossgenonly)
865             __SkipMSCorLib=1
866             __SkipCoreCLR=1
867             __CrossgenOnly=1
868             ;;
869         partialngen|-partialngen)
870             __PartialNgen=1
871             ;;
872
873         skiptests|-skiptests)
874             __SkipTests=1
875             ;;
876
877         skipnuget|-skipnuget|skipbuildpackages|-skipbuildpackages)
878             __SkipNuget=1
879             ;;
880
881         ignorewarnings|-ignorewarnings)
882             __IgnoreWarnings=1
883             __cmakeargs="$__cmakeargs -DCLR_CMAKE_WARNINGS_ARE_ERRORS=OFF"
884             ;;
885
886         cmakeargs|-cmakeargs)
887             if [ -n "$2" ]; then
888                 __cmakeargs="$__cmakeargs $2"
889                 shift
890             else
891                 echo "ERROR: 'cmakeargs' requires a non-empty option argument"
892                 exit 1
893             fi
894             ;;
895
896         bindir|-bindir)
897             if [ -n "$2" ]; then
898                 __RootBinDir="$2"
899                 if [ ! -d $__RootBinDir ]; then
900                     mkdir $__RootBinDir
901                 fi
902                 __RootBinParent=$(dirname $__RootBinDir)
903                 __RootBinName=${__RootBinDir##*/}
904                 __RootBinDir="$(cd $__RootBinParent &>/dev/null && printf %s/%s $PWD $__RootBinName)"
905                 shift
906             else
907                 echo "ERROR: 'bindir' requires a non-empty option argument"
908                 exit 1
909             fi
910             ;;
911         msbuildonunsupportedplatform|-msbuildonunsupportedplatform)
912             __msbuildonunsupportedplatform=1
913             ;;
914         numproc|-numproc)
915             if [ -n "$2" ]; then
916               __NumProc="$2"
917               shift
918             else
919               echo "ERROR: 'numproc' requires a non-empty option argument"
920               exit 1
921             fi
922             ;;
923         osgroup|-osgroup)
924             if [ -n "$2" ]; then
925               __BuildOS="$2"
926               shift
927             else
928               echo "ERROR: 'osgroup' requires a non-empty option argument"
929               exit 1
930             fi
931             ;;
932         rebuild|-rebuild)
933             echo "ERROR: 'Rebuild' is not supported.  Please remove it."
934             exit 1
935             ;;
936
937         -skiprestore)
938             __SkipRestoreArg="/p:RestoreDuringBuild=false"
939             ;;
940
941         -disableoss)
942             __SignTypeArg="/p:SignType=real"
943             ;;
944
945         -officialbuildid=*)
946             __Id=$(echo $1| cut -d'=' -f 2)
947             __OfficialBuildIdArg="/p:OfficialBuildId=$__Id"
948             ;;
949
950         -staticanalyzer)
951             __StaticAnalyzer=1
952             ;;
953
954         --)
955             # Skip -Option=Value style argument passing
956             ;;
957
958         *)
959             __UnprocessedBuildArgs="$__UnprocessedBuildArgs $1"
960             ;;
961     esac
962
963     shift
964 done
965
966 __CommonMSBuildArgs="/p:__BuildArch=$__BuildArch /p:__BuildType=$__BuildType /p:__BuildOS=$__BuildOS $__OfficialBuildIdArg $__SignTypeArg $__SkipRestoreArg"
967
968 # Configure environment if we are doing a verbose build
969 if [ $__VerboseBuild == 1 ]; then
970     export VERBOSE=1
971     __CommonMSBuildArgs="$__CommonMSBuildArgs /v:detailed"
972 fi
973
974 # Set default clang version
975 if [[ $__ClangMajorVersion == 0 && $__ClangMinorVersion == 0 ]]; then
976     if [[ "$__BuildArch" == "arm" || "$__BuildArch" == "armel" ]]; then
977         __ClangMajorVersion=5
978         __ClangMinorVersion=0
979     else
980         __ClangMajorVersion=3
981         __ClangMinorVersion=9
982     fi
983 fi
984
985 if [[ "$__BuildArch" == "armel" ]]; then
986     # Armel cross build is Tizen specific and does not support Portable RID build
987     __PortableBuild=0
988 fi
989
990 if [ $__PortableBuild == 0 ]; then
991     __CommonMSBuildArgs="$__CommonMSBuildArgs /p:PortableBuild=false"
992 fi
993
994 # Set dependent variables
995 __LogsDir="$__RootBinDir/Logs"
996 __MsbuildDebugLogsDir="$__LogsDir/MsbuildDebugLogs"
997
998 # Set the remaining variables based upon the determined build configuration
999 __BinDir="$__RootBinDir/Product/$__BuildOS.$__BuildArch.$__BuildType"
1000 __PackagesBinDir="$__BinDir/.nuget"
1001 __ToolsDir="$__RootBinDir/tools"
1002 __TestWorkingDir="$__RootBinDir/tests/$__BuildOS.$__BuildArch.$__BuildType"
1003 export __IntermediatesDir="$__RootBinDir/obj/$__BuildOS.$__BuildArch.$__BuildType"
1004 __TestIntermediatesDir="$__RootBinDir/tests/obj/$__BuildOS.$__BuildArch.$__BuildType"
1005 __isMSBuildOnNETCoreSupported=0
1006 __CrossComponentBinDir="$__BinDir"
1007
1008 __CrossArch="$__HostArch"
1009 if [ $__CrossBuild == 1 ]; then
1010     __CrossComponentBinDir="$__CrossComponentBinDir/$__CrossArch"
1011 fi
1012 __CrossGenCoreLibLog="$__LogsDir/CrossgenCoreLib_$__BuildOS.$__BuildArch.$__BuildType.log"
1013
1014 # init the target distro name
1015 initTargetDistroRid
1016
1017 # Init if MSBuild for .NET Core is supported for this platform
1018 isMSBuildOnNETCoreSupported
1019
1020 # CI_SPECIFIC - On CI machines, $HOME may not be set. In such a case, create a subfolder and set the variable to set.
1021 # This is needed by CLI to function.
1022 if [ -z "$HOME" ]; then
1023     if [ ! -d "$__ProjectDir/temp_home" ]; then
1024         mkdir temp_home
1025     fi
1026     export HOME=$__ProjectDir/temp_home
1027     echo "HOME not defined; setting it to $HOME"
1028 fi
1029
1030 # Specify path to be set for CMAKE_INSTALL_PREFIX.
1031 # This is where all built CoreClr libraries will copied to.
1032 export __CMakeBinDir="$__BinDir"
1033
1034 # Configure environment if we are doing a cross compile.
1035 if [ $__CrossBuild == 1 ]; then
1036     export CROSSCOMPILE=1
1037     if ! [[ -n "$ROOTFS_DIR" ]]; then
1038         export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__BuildArch"
1039     fi
1040 fi
1041
1042 # Make the directories necessary for build if they don't exist
1043 setup_dirs
1044
1045 # Set up the directory for MSBuild debug logs.
1046 export MSBUILDDEBUGPATH="${__MsbuildDebugLogsDir}"
1047
1048 # Check prereqs.
1049 check_prereqs
1050
1051 # Restore the package containing profile counts for profile-guided optimizations
1052 restore_optdata
1053
1054 # Generate event logging infrastructure sources
1055 generate_event_logging
1056
1057 # Build the coreclr (native) components.
1058 __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion -DCLR_CMAKE_PGO_OPTIMIZE=$__PgoOptimize"
1059
1060 # [TODO] Remove this when the `build-test.sh` script properly builds and deploys test assets.
1061 if [ $__SkipTests != 1 ]; then
1062     echo "Adding CMake flags to build native tests for $__BuildOS.$__BuildArch.$__BuildType"
1063     __ExtraCmakeArgs="$__ExtraCmakeArgs -DCLR_CMAKE_BUILD_TESTS=ON"
1064 fi
1065
1066 build_native $__SkipCoreCLR "$__BuildArch" "$__IntermediatesDir" "$__ExtraCmakeArgs" "CoreCLR component"
1067
1068 # Build cross-architecture components
1069 if [ $__SkipCrossArchNative != 1 ]; then
1070     if [[ $__CrossBuild == 1 ]]; then
1071         build_cross_architecture_components
1072     fi
1073 fi
1074
1075 # Build System.Private.CoreLib.
1076
1077 build_CoreLib
1078
1079 if [ $__CrossgenOnly == 1 ]; then
1080     build_CoreLib_ni "$__BinDir/crossgen"
1081 fi
1082
1083 # Generate nuget packages
1084 if [ $__SkipNuget != 1 ]; then
1085     generate_NugetPackages
1086 fi
1087
1088
1089 # Build complete
1090
1091 echo "Repo successfully built."
1092 echo "Product binaries are available at $__BinDir"
1093 exit 0